freeslot("sfx_chcool")

sfxinfo[sfx_chcool].caption = "\"Shadow, you're so cool!\""
sfxinfo[sfx_chcool].priority = 255
sfxinfo[sfx_chcool].flags = SF_X2AWAYSOUND | SF_X4AWAYSOUND | SF_X8AWAYSOUND

/*freeslot("S_PLAY_TEMPWAIT")

states[S_PLAY_TEMPWAIT] = {
	sprite = states[S_PLAY_WAIT].sprite,
	frame = states[S_PLAY_WAIT].frame,
	tics = 35,
	action = states[S_PLAY_WAIT].action,
	var1 = states[S_PLAY_WAIT].var1,
	var2 = states[S_PLAY_WAIT].var2,
	nextstate = S_PLAY_STND
}*/

local function attemptBreakFloor(player)
	for rover in player.mo.subsector.sector.ffloors() do
		if rover.flags & FF_EXISTS and rover.flags & FF_BUSTUP then
			if (player.mo.z + (player.mo.height/2) > rover.topheight) and (rover.topheight > player.mo.z - (player.mo.height/2)) then //if the player is close enough in height to the breakable floor
				EV_CrumbleChain(rover) //break it!
			end
		end
	end
end

addHook("ThinkFrame", do
	for player in players.iterate do
		if not player.mo then
			continue
		end
		if player.mo.drytimer == nil then
			player.mo.drytimer = 0 //Negative: Player is not Charmy, but was Charmy. Negate the value to get the drytimer. Zero: Dry. Positive: Time until dry.
		end
		if player.mo.skin ~= "charmy" then
			if player.mo.wasCharmy then
				player.mo.drytimer = -$
				player.mo.color = player.skincolor
				player.mo.colorized = false
				player.mo.wasCharmy = false
			end
			continue
		end
		
		player.mo.wasCharmy = true
		
		if player.mo.drytimer < 0 then
			player.mo.drytimer = -$
			player.mo.color = SKINCOLOR_BLUE
			player.mo.colorized = true
		end
		
		if player.mo.state == S_PLAY_WALK and leveltime % 14 == 0 then //buzz when moving
			S_StartSound(mo, sfx_buzz4)
		end
		if player.mo.state == S_PLAY_RUN and leveltime % 7 == 0 then
			S_StartSound(mo, sfx_buzz4)
		end
		
		/*if player.mo.state == S_PLAY_WAIT then
			player.mo.state = S_PLAY_TEMPWAIT
		end*/
		
		if player.mo.eflags & MFE_JUSTHITFLOOR then
			attemptBreakFloor(player)
		end
		
		if not player.coolcooldown then
			if player.cmd.buttons & BT_CUSTOM1 then
				local shadowExists = false
				for tplayer in players.iterate do
					if tplayer.mo and tplayer.mo.skin == "shadow" then
						shadowExists = true
						break
					end
				end
				if shadowExists then
					S_StartSoundAtVolume(mo, sfx_chcool, 255) //:)
					player.coolcooldown = TICRATE * 10
				end
			end
		else
			player.coolcooldown = $ - 1
		end
		--player.bob = 0
		
		if player.powers[pw_tailsfly] then
			if not player.charmy_wasflying then
				player.normalspeed = skins[player.mo.skin].normalspeed * 2
				player.charmy_wasflying = true
				player.powers[pw_tailsfly] = 16*TICRATE
			end
		else
			if player.charmy_wasflying then
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.fly1 = 0
				player.charmy_wasflying = false
			end
		end
		
		if player.powers[pw_super] or (player.powers[pw_shield] & SH_PROTECTFIRE) then
			player.charability = CA_FLY
			
			if not player.powers[pw_super] then
				player.mo.color = player.skincolor
			end
			player.mo.colorized = false
			
			player.mo.drytimer = 0
		else
			local hasWaterShield = player.powers[pw_shield] & SH_PROTECTWATER
			if player.mo.eflags & MFE_UNDERWATER and not hasWaterShield then
				player.charability = CA_NONE
				player.powers[pw_tailsfly] = 0
				
				player.mo.color = SKINCOLOR_BLUE
				if gametyperules & GTR_TEAMS and player.ctfteam == 1 then
					player.mo.color = SKINCOLOR_RED
				end
				player.mo.colorized = true
				
				player.mo.drytimer = 30 * TICRATE
			else
				local FF_BLOCKSPRECIP = FF_EXISTS | FF_CUTLEVEL
				if (not hasWaterShield) and (globalweather == PRECIP_STORM or globalweather == PRECIP_RAIN or globalweather == PRECIP_STORM_NOSTRIKES) and (player.mo.subsector.sector.ceilingpic == "F_SKY1" and not (player.mo.ceilingrover and (player.mo.ceilingrover.flags & FF_BLOCKSPRECIP == FF_BLOCKSPRECIP))) then //man i spent soo long figuring this out...
					player.charability = CA_NONE
					player.powers[pw_tailsfly] = 0
					
					player.mo.color = SKINCOLOR_BLUE
					if gametyperules & GTR_TEAMS and player.ctfteam == 1 then
						player.mo.color = SKINCOLOR_RED
					end
					player.mo.colorized = true
				else
					player.mo.drytimer = ($ and ($ - 1)) or 0
					if not player.mo.drytimer then
						player.charability = CA_FLY
						if player.mo.colorized then
							player.mo.color = player.skincolor
							player.mo.colorized = false
						end
					else
						player.charability = CA_NONE
						player.powers[pw_tailsfly] = 0
						
						player.mo.color = SKINCOLOR_ICY
						if gametyperules & GTR_TEAMS and player.ctfteam == 1
							player.mo.color = SKINCOLOR_SALMON
						end
						player.mo.colorized = true
					end
				end
			end
		end
		
		
		if (not P_IsObjectOnGround(player.mo)) and player.charability == CA_FLY and (player.wasongroundlastturn or player.powers[pw_justsprung]) and (not player.powers[pw_tailsfly]) then
			player.pflags = $|PF_JUMPED
		end
		
		player.wasongroundlastturn = P_IsObjectOnGround(player.mo)
	end
end)

addHook('JumpSpecial', function(player)
	if player.mo and player.mo.valid then
		if player.mo.skin == "charmy" then
			if player.powers[pw_tailsfly] and (player.cmd.buttons & BT_JUMP) then
				player.fly1 = 1
			end
		end
	end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.player then
		if (target.skin == "charmy" and damagetype & DMG_FIRE and target.player.powers[pw_carry] ~= CR_NIGHTSMODE) then
			target.player.charability = CA_FLY
			
			target.color = target.player.skincolor
			target.colorized = false
			
			target.drytimer = 0
		end
	end
end
, "MT_PLAYER")

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.skin == "charmy" then
			player.bob = 0
			player.viewz = player.mo.z + player.viewheight + (player.mo.height - 2 * player.viewheight) * ((player.mo.eflags & MFE_VERTICALFLIP) / MFE_VERTICALFLIP)
		end
	end
end)